/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
/* (C) Tamer Kulaksizoglu                                                                                                                           */
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::EstOLS()
{
	m_vCoef = <>;
	m_vCoefP = <>;
	m_vCoefSE = <>;
	m_vCoefT = <>;
	m_mCoefVC = <>;
	m_iK = 0;
	m_iN = 0;
	m_vResid = <>;
	m_eRobust = NONE;
	m_dRSq = 0;
	m_dRSS = 0;
	m_dSigma = 0;
	m_dSigmaSq = 0;
	m_mX = <>;
	m_mXtXi = <>;
	m_vY = <>;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::Coef()
{
	return m_vCoef;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::CoefP()
{
	return m_vCoefP;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::CoefSE()
{
	return m_vCoefSE;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::CoefT()
{
	return m_vCoefT;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::CoefVCM()
{
	if (m_eRobust == NONE)
		m_mCoefVC = m_dSigmaSq * m_mXtXi;
	else if (m_eRobust == HC0)
	{
		decl vwi = sqr(m_vResid);
		m_mCoefVC = m_mXtXi * (m_mX'(vwi .* m_mX)) * m_mXtXi;
	}
	else if (m_eRobust == HC1)
	{
		decl dAdj = m_iN / (m_iN - m_iK);
		decl vResidSq = sqr(m_vResid);
		decl vwi = dAdj .* vResidSq;
		m_mCoefVC = m_mXtXi * (m_mX'(vwi .* m_mX)) * m_mXtXi;
	}
	else if (m_eRobust == HC2)
	{
		decl mHat = outer(m_mX, m_mXtXi); // outer(X,S) returns XSX'
		decl vhi = diagonal(mHat)';
		decl vResidSq = sqr(m_vResid);
		decl vwi = vResidSq ./ (1 - vhi);
		m_mCoefVC = m_mXtXi * (m_mX'(vwi .* m_mX)) * m_mXtXi;
	}
	else if (m_eRobust == HC3)
	{
		decl mHat = outer(m_mX, m_mXtXi); // outer(X,S) returns XSX'
		decl vhi = diagonal(mHat)';
		decl vResidSq = sqr(m_vResid);
		decl vwi = vResidSq ./ sqr(1 - vhi);
		m_mCoefVC = m_mXtXi * (m_mX'(vwi .* m_mX)) * m_mXtXi;
	}
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::Estimate()
{
	olsc(m_vY, m_mX, &m_vCoef, &m_mXtXi);
	decl vYhat = m_mX * m_vCoef;
	m_vResid = m_vY - vYhat;
	m_dRSS = sumsqrc(m_vResid);
	decl iDF = m_iN - m_iK;
	m_dSigmaSq = m_dRSS / iDF;
	m_dSigma = sqrt(m_dSigmaSq);
	this->CoefVCM();
	decl vCoefV = diagonal(m_mCoefVC)';
	m_vCoefSE = sqrt(vCoefV);
	m_vCoefT = m_vCoef ./ m_vCoefSE;
	m_vCoefP = 2 * tailt(fabs(m_vCoefT), m_iN - m_iK);
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::Resid()
{
	return m_vResid;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::RSq()
{
	decl dRSqCen = 1 - m_dRSS / (sumsqrc(m_vY - meanc(m_vY)));
	return dRSqCen;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::RSS()
{
	return m_dRSS;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::SetData(const vY, const mX)
{
	m_iK = columns(mX);
	m_iN = rows(vY);
	m_mX = mX;
	m_vY = vY;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::SetRobust(const eRobust)
{
	m_eRobust = eRobust;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::SetX(const mX)
{
	m_iK = columns(mX);
	m_mX = mX;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::SetY(const vY)
{
	m_iN = rows(vY);
	m_vY = vY;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::Sigma()
{
	return m_dSigma;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::XtXi()
{
	return m_mXtXi;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
EstOLS::~EstOLS()
{
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
/* (C) Tamer Kulaksizoglu                                                                                                                           */
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */