/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
/* (C) Tamer Kulaksizoglu                                                                                                                           */
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
Misc::AreEqual(const mExpected, const mActual, const sTest, const dEps)
{
	if ((isint(mExpected) || isdouble(mExpected)) && (isint(mActual) || isdouble(mActual))) // if mExpected and mActual are scalars
	{
		decl iAcc = fabs(mExpected - mActual) .<= dEps;
		if (iAcc == 1)
			println(sTest, "Passed (", "%#1.1e", dEps, ")");
		else
			println(sTest, "FAILED!!!!! (", "%#1.1e", dEps, ")");
	}
	else if (ismatrix(mExpected) && ismatrix(mActual)) // if mExpected and mActual are matrices
	{
		if ((rows(mExpected) != rows(mActual)) || (columns(mExpected) != columns(mActual)))
		{
			eprint("\nException (CL95::Misc::AreEqual): arguments 1 and 2 must have the same dimensions\n");
			exit(0);
		}
		decl iAcc = sumr(sumc(fabs(mExpected - mActual) .<= dEps));
		if (iAcc == rows(mExpected) * columns(mExpected))
			println(sTest, "Passed (", "%#1.1e", dEps, ")");
		else
			println(sTest, "FAILED!!!!! (", "%#1.1e", dEps, ")");
	}
	else
	{
		eprint("\nException (CL95::Misc::AreEqual): arguments 1 and 2 must be either scalars or matrices\n");
		exit(0);
	}
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
Misc::Comb(const m1, const m2) // m1 and m2 must have the same number of rows and columns
{
	decl iN = rows(m1) + rows(m2);
	decl iK = max(columns(m1), columns(m2));
	decl m3 = new matrix[iN][iK];
	decl cntr = -1;
	for (decl i = 0; i < iN; i += 2)
	{
		m3[i][] = m1[++cntr][];
		m3[i+1][] = m2[cntr][];
	}
	return m3;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
Misc::ToMatrix(const arr)
{
	decl iR = sizeof(arr);
	decl vX = new matrix[iR][1];
	for (decl ir = 0; ir < iR; ir++)
		vX[ir][0] = arr[ir][0];
	return vX;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
/* (C) Tamer Kulaksizoglu                                                                                                                           */
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */