/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
/* (C) Tamer Kulaksizoglu                                                                                                                           */
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
TestADF::TestADF()
{
	m_vCoefT = <>;
	m_bInt = FALSE;
	m_iMaxLag = 0; // iMaxLag = 0 => Dickey-Fuller test
	m_iN = 0;
	m_oOLS = new CL95::EstOLS();
	m_bTrend = FALSE;
	m_vY = <>;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
TestADF::GetN()
{
	return m_iN;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
TestADF::Run()
{
	decl vY_1 = lag(m_vY, 1);
	decl vDY = diff(m_vY, 1);
	decl mDYL = lag(vDY, range(0, m_iMaxLag));
	decl mData = deleter(vY_1 ~ mDYL);
	decl iN = rows(mData);
	decl iK = columns(mData);
	decl vY = mData[][1];
	decl mX = mData[][0] ~ submat(mData, 0, iN - 1, 2, iK); // submat may return <>
	if (m_bInt == TRUE)
		mX = mX ~ 1;
	if (m_bTrend == TRUE)
		mX = mX ~ range(1, iN)';
	m_oOLS.SetData(vY, mX);
	m_oOLS.Estimate();
	m_vCoefT = m_oOLS.CoefT();
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
TestADF::SetData(const vY)
{
	m_iN = rows(vY);
	m_vY = vY;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
TestADF::SetInt(const bInt)
{
	m_bInt = bInt;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
TestADF::SetMaxLag(const iMaxLag)
{
	m_iMaxLag = iMaxLag;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
TestADF::SetTrend(const bTrend)
{
	m_bTrend = bTrend;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
TestADF::TestStat()
{
	return m_vCoefT[0];
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
TestADF::~TestADF()
{
	delete m_oOLS;
}
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */
/* (C) Tamer Kulaksizoglu                                                                                                                           */
/* oxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxoxox */